class_name MatchController
extends Controller

signal done(controller, steps)


var noticed_changes := []

var strength := Vector2.ZERO
var is_reference := false setget set_is_reference
var grow_weak := true
var grow_strong := false
var block_confirm := false
var dont_process := true # Hack, because set_process polls our input...

func _ready() -> void:
	yield(get_tree(), "idle_frame")
	while !yield(self, "confirm_changed"):
		pass
	connect("confirm_changed", self, "on_confirm_changed")
	dont_process = false


func on_confirm_changed(confirmed: bool) -> void:
	if confirmed and !block_confirm:
		block_confirm = true
		noticed_changes.push_back(strength.x + (2 if strength.y > 0 else 0) + strength.y)
		yield(get_tree().create_timer(rand_range(0.5, 2)), "timeout")
		block_confirm = false


func _process(delta: float) -> void:
	if dont_process:
		return
	if !block_confirm:
		if grow_weak:
			strength.x += 0.05 * delta
			strength.x = clamp(strength.x, 0, 1)
			if is_equal_approx(strength.x, 1):
				grow_weak = false
				grow_strong = true
				strength.x = 0
		if grow_strong:
			strength.y += 0.05 * delta
			strength.y = clamp(strength.y, 0, 1)
			if is_equal_approx(strength.y, 1):
				grow_weak = false
				grow_strong = false
				set_process(false)
				emit_signal("done", self, noticed_changes)
	
	vibrate(strength.x, strength.y, delta*2)


func set_is_reference(value: bool) -> void:
	is_reference = value
	if !is_inside_tree():
		yield(self, "ready")
	var colour := Color.green if value else Color.darkred
	steam.setLEDColor(handle, colour.r8, colour.g8, colour.b8, 0)
